#ifndef SYNC_H
#define SYNC_H

#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

typedef struct _sync_mon {
    pthread_mutex_t m;
    pthread_cond_t c;
    int nblocked;
    int nthreads;
} sync_t;

void sync_init(sync_t *s, int n);
void sync_wait(sync_t *s);

#endif
