#include <pthread.h>
#include <stdio.h>

void * mythread(void *arg) 
{
    int myindex = *((int *)arg);
    printf("This is the first thread, index %d!\n", myindex);
    printf("My thread id is: %ld\n", pthread_self());
    
    return 0;
}

int main()
{
    pthread_t tid[10];
    int index[10];
    int i;
        
    printf("This is the main\n");
    for (i=0; i<10; i++) {
        index[i] = i;
        pthread_create(&tid[i], 0, mythread, &index[i]);
    }
    
    printf("Main created 10 threads\n");
    for (i=0; i<10; i++) 
        pthread_join(tid[i], 0);
    printf("All threads terminated\n");
}

