#ifndef SYNC_H
#define SYNC_H

#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

typedef struct _sync {
    sem_t m;
    sem_t s[2];
    int turn;
    int nblocked[2];
    int nthreads;
} sync_t;

void sync_init(sync_t *s, int n);
void sync_wait(sync_t *s);

#endif
